\documentclass{beamer} %[handout]

\mode<presentation>
{
	\usecolortheme{beaver}
}
\setbeamercovered{transparent}
\addtobeamertemplate{navigation symbols}{}{%
    \usebeamerfont{footline}%
    \usebeamercolor[fg]{footline}%
    \hspace{1em}%
    \insertframenumber/\inserttotalframenumber
}

\usepackage[english]{babel}
\usepackage{pgf}
\usepackage{tikz}
\usetikzlibrary{calc}
\usepackage{soul}
%\usepackage{fancybox}
%\usepackage{framed}


%\usepackage{pgf,pgfarrows,pgfnodes,pgfautomata,pgfheaps,pgfshade}

\usepackage[noline]{algorithm2e}
\usepackage{graphicx}
\usepackage{xcolor}
\usepackage{colortbl}
\usepackage{psfont}
\usepackage{multicol}

\setbeamercovered{dynamic}
\newcommand{\instance}[1]{\textcolor{green!50!black}{{#1}}}
\newcommand{\ignore}[1]{}

\begin{document}
\title{Profile Minimisation Problem for Sparse Matrices}
\author{M A Hakim Newton}

\begin{frame}{}	
	\maketitle
\end{frame}

\begin{frame}{Archeological Seriation (1)}
\includegraphics[width=\textwidth,height=0.85\textheight]{pottery-seriation}
\end{frame}

\begin{frame}{Archeological Seriation (2)}
\begin{columns}
\column{0.47\textwidth}
\includegraphics[width=\columnwidth]{seriation-notdated}
\begin{itemize}
\itemsep0ex
\item Rows: Features
\item Columns: Artefacts
\item Ordering of Features
\item Orderig of Artefacts
\end{itemize}
\column{0.47\textwidth}
\includegraphics[width=\columnwidth]{seriation-dated}
\begin{itemize}
\item Artefacts having the same single feature
\item Artefacts having similar sets of features
\end{itemize}
\end{columns}
\vfill
\centerline{\alert{Reordering of sparse matrix rows and columns}}
\end{frame}

\begin{frame}{Linear Equations and Matrices}
\includegraphics[width=\textwidth]{system-lin-equation}
\vfill
\centerline{\alert{The matrix is sparse in many engineering application domains}}
\end{frame}

\begin{frame}{Sparse Matrix Reordering}
\includegraphics[width=\textwidth]{matrix-reordering}
\vfill
\begin{itemize}
\item Band matrices have only a few diagonals: bandwidth.
\item Band matrices need less memory and less computing.
\end{itemize}
\end{frame}

\begin{frame}{Applications and Related Problems}
\begin{exampleblock}{Some Sparse Matrix Applications}
\begin{itemize}
\item Relative dating of fossils, tools, jewels  
\item Cholesky Factorisation of Matrices
\item Human Genome Project: Gene Identification
\item Finite Elements in Civil Engineering
\item Integrated circuit in Electrical Engineering
\item Power system networks in Electrical Engineering
\item Chemical process modelling in Chemical Engineering
\end{itemize}
\end{exampleblock}
\begin{alertblock}{Symmetric Sparse Matrix Problems}
\begin{itemize}
\item \structure{Bandwidth minimisation problem}
\item \alert{Profile minimisation problem}
\item Sum-Cut minimisation problem
\item Wavefront minimisation problem
\end{itemize}
\end{alertblock}
\end{frame}

\begin{frame}{Bandwidths and Profiles}
\includegraphics[width=\textwidth,height=0.85\textwidth]{matrix-graph}
\end{frame}


\begin{frame}{Permutations and Linear Graph Drawing}
\includegraphics[width=\textwidth]{profile-graph}
\centerline{\alert{Max for Bandwidth and Sum for Profile}}
\end{frame}

\begin{frame}{Cuthill-Mckee (CM) and Reverse CM Heuristics}
\includegraphics{cuthill-mckee}
\begin{itemize}
\item CM: Breadth-First Order of nodes from a given root node
\item RCM: Ascending Degree Order among Siblings of any node
\item RCM appears to be better than CM for profile minimisation 
\end{itemize}
\end{frame}

\begin{frame}{CM/RCM Variants}
\begin{exampleblock}{Algorithm Variants}
\begin{itemize}
\item Performance depends on the selection of the root node.
\item Select a minimum-degree vertex as the root node.
\item Select a pseudo-peripheral node as the root node.
\begin{itemize}
	\item How to find a pseudo-peripheral node for a given graph
\end{itemize}
\end{itemize}
\end{exampleblock}
\begin{block}{Available Implementations}
\begin{itemize}
\item Very well-known and very popular 
\item Implemented methods are in matlab, python
\end{itemize}
\end{block}
\begin{alertblock}{Algorithm Pitfalls}
\begin{itemize}
\item CM/RCM algorithms do not use the objective directly!
\end{itemize}
\end{alertblock}
\vfill
\centerline{\alert{Other heuristics and metaheuristic algorithms are not covered now!}}
\end{frame}

\begin{frame}{Proposed Permutation Heuristics}
\centering
\begin{tikzpicture}
\node[draw] (A) at (0,0) {A}; 
\node (AB) at (-1,-1) {AB}; 
\node[draw] (BA) at (1,-1) {BA};
\node (BAC) at (-2,-2) {BAC};
\node[draw] (BCA) at (0,-2) {BCA}; 
\node (CBA) at (2,-2) {CBA};
\node[draw] (BCAD) at (-3,-3) {BCAD};
\node (BCAD) at (-1,-3) {BCDA};
\node (BCAD) at (1,-3) {BDCA};
\node (BCAD) at (3,-3) {DBCA};
\end{tikzpicture}
\vfill
\begin{itemize}
\item Given an \alert{initial ordering} ABCD, start from empty permutation 
\item Repeat following two steps until you get full permutations 
\item Generate permutations by adding only one node at a time
\item Select the best permutation from the generated ones
\end{itemize}
\end{frame}

\begin{frame}{Experimental Setttings}
\begin{columns}
\column{0.42\textwidth}
\begin{block}{Existing ordering}
\begin{enumerate}
\item Given order
\item Reverse order
\item Degree order
\item Reverse degree order
\item CM order
\item RCM order
\item CMGL order
\item RCMGL order
\end{enumerate}
\end{block}
\column{0.52\textwidth}
\begin{block}{Proposed Ordering}
\begin{enumerate}
\item Use 8 existing ordering as intial orderings
\item Use the permutation generation procedure
\end{enumerate}
\end{block}
\begin{block}{Experimental Settings}
\begin{enumerate}
\item 3 sets of instances 
\item d4tree 91 hb 62 kgraph 138
\end{enumerate}
\end{block}
\end{columns}
\end{frame}

\begin{frame}{Experimental Results}
\begin{columns}
\column{0.47\textwidth}
\centerline{\alert{d4tree}}
\includegraphics[width=\columnwidth]{d4tree-result}
\centerline{\alert{hb}}
\includegraphics[width=\columnwidth]{hb-result}
\column{0.47\textwidth}
\centerline{\alert{kgraph}}
\includegraphics[width=\columnwidth]{kgraph-result}
\begin{itemize}
\item Very good results in d4tree instances
\item Slightly worse results in hb instances
\item No improvement in kgraph instances
\end{itemize}
\end{columns}
\end{frame}

\begin{frame}{Further Work}
\begin{block}{Further Versions}
\begin{itemize}
\item Based on initial orderings
\item Based on certain adjustments
\end{itemize}
\end{block}
\begin{block}{Further Experiments}
\begin{itemize}
\item More benchmark instances
\item More analyses of results
\end{itemize}
\end{block}
\begin{block}{Metaheuristic Algorithms}
\begin{itemize}
\item Exist local search and population based algorithms
\item Plan to develop constraint-directed search algorithms
\end{itemize}
\end{block}
\end{frame}

\begin{frame}{}
\vfill
\centerline{\Huge \instance{Thank You}}
\vfill
\end{frame}


\end{document}

